static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/global/sect.c,v 2.5 1995/10/11 02:58:32 empire Exp $";

/*
 * sect.c
 *
 * sector designation characteristics -- one entry per
 * designation type
 * order must agree with sect.h
 */

#include "misc.h"
#include "sect.h"
#include "product.h"
#include "file.h"
#include "toolkit.h"

struct  dchrstr dchr[SCT_MAXDEF+2]  = {
/*
mnem prd     mcst  flg    pkg ostr dstr value $ bld lcm hcm   name    */
SCT_CLASS, '.', 0,        0, NAVOK,  NPKG,  0,   0,   0, 0,  0,  0,  0,  "sea",
SCT_CLASS, '^', P_MDUST, 25, 0,      NPKG,  4,   8,   5, 0,  1,  0,  0, "mountain",
SCT_CLASS, 's', 0,        0, 0,      NPKG,  0,  99, 127, 0,  0,  0,  0, "sanctuary",
SCT_CLASS, '\\',0,        0, 0,      NPKG,  0,  99,   0, 0,  0,  0,  0, "wasteland",
SCT_CLASS, '-', 0,        2, 0,      NPKG,  2,   2,   1, 0,  0,  0,  0, "wilderness",
#ifdef BIG_CITY
SCT_CLASS, 'c', 0,        2, NAV_02, UPKG,  2,   4,  30, 0,10, 1,  2, "city",
#else
SCT_CLASS, 'c', 0,        2, 0,      NPKG,  2,   4,  30, 0,  1,  0,  0, "capital",
#endif /* BIG_CITY */
SCT_CLASS, 'u', P_URAN,   2, 0,      NPKG,  2,   3,  15, 0,  1,  0,  0, "uranium mine",
SCT_CLASS, 'p', P_HLEV,   2, 0,      NPKG,  2,   2,   5, 0,  1,  0,  0, "park",
SCT_CLASS, 'd', P_GUN,    2, 0,      NPKG,  2,   2,   7, 0,  1,  0,  0, "defense plant",
SCT_CLASS, 'i', P_SHELL,  2, 0,      NPKG,  2,   2,   6, 0,  1,  0,  0, "shell industry",
SCT_CLASS, 'm', P_IRON,   2, 0,      NPKG,  2,   3,   5, 0,  1,  0,  0, "mine",
SCT_CLASS, 'g', P_DUST,   2, 0,      NPKG,  2,   3,   8, 0,  1,  0,  0, "gold mine",
SCT_CLASS, 'h', 0,        2, NAV_02, WPKG,  2,   2,  12, 0,  1,  0,  0, "harbor",
SCT_CLASS, 'w', 0,        2, 0,      WPKG,  2,   2,   7, 0,  1,  0,  0, "warehouse",
SCT_CLASS, '*', 0,        2, 0,      NPKG,  2,   1,  12, 0,  1,  0,  0, "airfield",
SCT_CLASS, 'a', P_FOOD,   2, 0,      NPKG,  2,   2,   2, 0,  1,  0,  0, "agribusiness",
SCT_CLASS, 'o', P_OIL,    2, 0,      NPKG,  2,   2,   5, 0,  1,  0,  0, "oil field",
SCT_CLASS, 'j', P_LCM,    2, 0,      NPKG,  2,   2,   3, 0,  1,  0,  0, "light manufacturing",
SCT_CLASS, 'k', P_HCM,    2, 0,      NPKG,  2,   2,   4, 0,  1,  0,  0, "heavy manufacturing",
SCT_CLASS, 'f', 0,        2, 0,      NPKG,  4,   8,  10, 0, 5,0, 5, "fortress",
SCT_CLASS, 't', P_TLEV,   2, 0,      NPKG,  2,   2,  10, 0,  1,  0,  0, "technical center",
SCT_CLASS, 'r', P_RLEV,   2, 0,      NPKG,  2,   2,   9, 0,  1,  0,  0, "research lab",
SCT_CLASS, 'n', 0,        2, 0,      NPKG,  2,   3,  10, 0,  1,  0,  0, "nuclear plant",
SCT_CLASS, 'l', P_ELEV,   2, 0,      NPKG,  2,   2,   4, 0,  1,  0,  0, "library/school",
SCT_CLASS, '+', 0,        1, 0,      NPKG,  1,   1,   3, 0,  1,  0,  0, "highway",
SCT_CLASS, ')', 0,        2, 0,      NPKG,  2,   2,   4, 0,  1,  0,  0, "radar installation",
SCT_CLASS, '!', 0,        2, 0,      NPKG,  2,   2,  12, 0,  1,  0,  0, "headquarters",
SCT_CLASS, '#', 0,        1, 0,      NPKG,  2,   2,   4, 0,  1,  0,  0, "bridge head",
SCT_CLASS, '=', 0,        1, NAV_60, NPKG,  1,   1,   5, 0,  1,  0,  0, "bridge span",
SCT_CLASS, 'b', P_BAR,    2, 0,      BPKG,  2,   4,  10, 0,  1,  0,  0, "bank",
SCT_CLASS, '%', P_PETROL, 2, 0,      NPKG,  2,   2,   2, 0,  1,  0,  0, "refinery",
SCT_CLASS, 'e', 0,        2, 0,      NPKG,  2,   3,   7, 0,  1,  0,  0, "enlistment center",
#ifdef MARKET
SCT_CLASS, 'v', 0,        2, 0,      NPKG,  2,   2,   4, 0,  1,  0,  0, "trading post",
#else
SCT_CLASS,   0, 0,        0, 0,      0,     0,   0,   0, 0,  0,  0,  0, 0,
#endif MARKET
SCT_CLASS,   0, 0,        0, 0,      0,     0,   0,   0, 0,  0,  0,  0, 0,

};

int	sct_maxno = (sizeof(dchr) / sizeof(struct dchrstr)) - 1;
