#ifndef lint
static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/subs/land.c,v 2.3 1995/09/26 18:38:20 empire Exp $";
#endif

/*
 * land.c
 *
 * land unit post-read and pre-write
 *
 */

#include "misc.h"
#include "player.h"
#include "var.h"
#include "file.h"
#include "land.h"
#include "ship.h"
#include "sect.h"
#include "xy.h"
#include "nat.h"
#include "deity.h"
#include "nsc.h"
#include "plane.h"

int
lnd_postread(ptr)
	s_char	*ptr;
{
	struct	lndstr *pp = (struct lndstr *) ptr;
	struct	shpstr theship;
	s_char	buf[128];

	if (pp->lnd_ship >= 0 && pp->lnd_own && pp->lnd_effic >= LAND_MINEFF) {
		if (!getship(pp->lnd_ship, &theship) ||
		    (theship.shp_effic < SHIP_MINEFF) || 
		    (theship.shp_own != pp->lnd_own)){
			sprintf(buf, "%s sunk!\n", prland(pp));
			mpr(pp->lnd_own, buf);
			pp->lnd_own = 0;
			pp->lnd_flags |= LND_NOSYNC;
			putland(pp->lnd_uid, pp);
			putland(pp->lnd_uid, pp);
		} else {
			/* wooof!  Carriers are a pain */
			if (pp->lnd_mission){
				/*
				 *  If the unit is on a mission centered
				 *  on it's loc, the op-area travels with
				 *  the unit.
				 */
				if ((pp->lnd_opx == pp->lnd_x) &&
					(pp->lnd_opy == pp->lnd_y)){
					pp->lnd_opx = theship.shp_x;
					pp->lnd_opy = theship.shp_y;
				}
			}
			pp->lnd_x = theship.shp_x;
			pp->lnd_y = theship.shp_y;
		}
	}
#ifdef MOB_ACCESS
	lnd_do_upd_mob(ptr);
#endif /* MOB_ACCESS */
	player->owner = (player->god || pp->lnd_own == player->cnum);
	return 1;
}

/*ARGSUSED*/
int
lnd_prewrite(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	lndstr *lp = (struct lndstr *) ptr;
	struct	lndstr land;

	if (lp->lnd_effic < LAND_MINEFF){
		lp->lnd_own = 0;
	}
	lp->ef_type = EF_LAND;
	lp->lnd_uid = n;

	if (lp->lnd_flags & LND_NOSYNC) {
		lp->lnd_flags &= ~LND_NOSYNC;
	} else {
		getland(n, &land);
		prewrite_sync(&land, lp);
	}

	return 1;
}

int
lnd_init(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	lndstr *lp = (struct lndstr *) ptr;

	lp->ef_type = EF_LAND;
	lp->lnd_uid = n;
	lp->lnd_own = 0;
}

s_char *
prland(lp)
	struct	lndstr	*lp;
{
	return prbuf("%s #%d", lchr[lp->lnd_type].l_name, lp->lnd_uid);
}


#define VALIDATE_EF_NAME "land"
#define VALIDATE_UID lp->lnd_uid
#define VALIDATE_X lp->lnd_x
#define VALIDATE_Y lp->lnd_y
#include "validate.h"

int
lnd_validate(uid, lp)
	int uid;
	struct lndstr *lp;
{
	struct	sctstr sect;

	validate_eq("ef_type", lp->ef_type, EF_LAND);
	validate_owner(lp->lnd_own);
	if (!lp->lnd_own)
		return;
	if (lp->lnd_ship == -1 &&
	    (!getsect(lp->lnd_x, lp->lnd_y, &sect) ||
	     sect.sct_own != lp->lnd_own)) {
		wu(0, lp->lnd_own, "%s was kidnapped by %s (#%d) and has disbanded\n",
		   prland(lp), cname(sect.sct_own), sect.sct_own);
		wu(0, 0, "%s was kidnapped by %s (#%d) and has disbanded\n",
		   prland(lp), cname(sect.sct_own), sect.sct_own);
		lp->lnd_own = 0;
		return;
		   
	}
	validate_eq("uid", lp->lnd_uid, uid);
	validate_between("type", lp->lnd_type, 0, lnd_maxno);
	validate_perc("eff", lp->lnd_effic);
	validate_between("mob", lp->lnd_mobil, -127, 127);
	validate_ge("tech", lp->lnd_tech, 0);
	validate_between("mission", lp->lnd_mission, 0, MI_LAST);
	validate_ge("ship", lp->lnd_ship, -1);
	validate_ge("harden", lp->lnd_harden, 0);
	validate_perc("retreat", lp->lnd_retreat);
 	if (validate_vector(lp->lnd_vtype, lp->lnd_vamt, lp->lnd_nv)) {
		wu(0,0,"land unit %d failed data validation.  An item was reduced to 9999\n", uid);
	}
}
