#if defined solaris
/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)scandir.c	5.2 (Berkeley) 3/9/86";
#endif LIBC_SCCS and not lint

/*
 * Scan the directory dirname calling select to make a list of selected
 * directory entries then sort using qsort and compare routine dcomp.
 * Returns the number of entries and a pointer to a list of pointers to
 * struct dirent (through namelist). Returns -1 if there were any errors.
 */

#ifndef	DIRSIZ_MACRO
#define	DIRSIZ_MACRO
#endif	/* DIRSIZ_MACRO */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>


int
sV_scandir(dir, dpp, select, sort)
	char *dir;		/* directory to read */
	struct dirent ***dpp;	/* directory entry pointer pointer */
	int (*select)();
	int (*sort)();
{
	DIR *dirp;
	int nsize;
	int nents;
	struct dirent *d, *tmp;

	d = (struct dirent *)malloc(sizeof(struct dirent) + pathconf(".", _PC_NAME_MAX) +1);
	if ( (dirp = opendir(dir)) == NULL)
		return -1;
	nsize = 100;
	*dpp = (struct dirent **)malloc(nsize * sizeof(struct dirent *));
	if ( (*dpp) == NULL )
		{
		closedir(dirp);
		return -1;
	}
	nents = 0;
	while ( (d = readdir_r(dirp, d)) != NULL)
		{
		if ( select != NULL && !(*select)(d) )
			continue;
		tmp = (struct dirent *)malloc(sizeof(struct dirent) + strlen(d->d_name) + 1);
		if ( tmp == NULL )
			return -1;
		tmp->d_ino = d->d_ino;
		tmp->d_reclen = d->d_reclen;
		strcpy(tmp->d_name, d->d_name);
		if ( nents > nsize )
			{
			*dpp = (struct dirent **)realloc((char *)*dpp, nsize * sizeof(struct dirent *));
			if ( *dpp == NULL )
				return -1;
	}
		(*dpp)[nents++] = tmp;
		}
				closedir(dirp);
	if (nents > 0 && sort != NULL )
		qsort(*dpp, nents, sizeof(struct dirent *), sort);
	return nents;
}

/*
 * Alphabetic order comparison routine for those who want it.
 */
sV_alphasort(d1, d2)
	struct dirent **d1, **d2;
{
	return(strcmp((*d1)->d_name, (*d2)->d_name));
}
#endif	/* hpux || solaris */
